defApplication('Home', 'HomeApp') {|app|

app.shortDescription = "This is a simple home app test" 
app.path="/root/pigeonCode/app 32000 33000 31000 > /root/pigeonCode/logfile" 


app.defMeasurement('infoHome') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('description',:string)
end

}


defApplication('Foreign', 'ForeignApp') {|app|

app.shortDescription = "This is a simple foreign app test" 
app.path="/root/pigeonCode/app 32000 33000 31000 > /root/pigeonCode/logfile" 


app.defMeasurement('infoForeign') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('description',:string)
end

}


defApplication('Pigeon', 'PigeonApp') {|app|

app.shortDescription = "This is a simple home app test" 
app.path="/root/pigeonCode/app 10.0.0.5 32000 33000 10.0.0.15 32000 33000 > /root/pigeonCode/logfile " 


app.defMeasurement('infoPigeon') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('location',:float)
     mp.defMetric('st',:float)
     mp.defMetric('et',:float)
     mp.defMetric('description',:string)
end


app.defMeasurement('locPigeon') do |mp|
     mp.defMetric('location',:float)
     mp.defMetric('description',:string)
end

}




defGroup('homeHosts', "omf.nicta.node5") {|node|

node.addApplication('Home') {|app|
#app.measure('info', :interval => 10)
app.measure('infoHome', :samples => 1)
}

}


defGroup('foreignHosts', "omf.nicta.node15") {|node|

node.addApplication('Foreign') {|app|
#app.measure('info', :interval => 10)
app.measure('infoForeign', :samples => 1)
}

}


defGroup('pigeons', "omf.nicta.node10") {|node|

node.addApplication('Pigeon') {|app|
#app.measure('info', :interval => 10)
app.measure('infoPigeon', :samples => 1)
app.measure('locPigeon', :samples => 1)
}

}



onEvent(:ALL_UP_AND_INSTALLED) do |event|
info "This is my first OMF experiment" 

wait 10

group("homeHosts").startApplications

group("foreignHosts").startApplications

wait 5

group("pigeons").startApplications

info "All my Applications are started now..." 

wait 1000

group("pigeons").exec("killall -s9 app")
 
group("homeHosts").exec("killall -s9 app")

group("foreignHosts").exec("killall -s9 app")

allGroups.stopApplications
info "All my Applications are stopped now." 

Experiment.done

end
