defApplication('Home', 'HomeApp') {|app|

app.shortDescription = "This is a simple home app." 
app.path="/root/Code/app 32000 33000 31000  > /root/Code/logfile" 


app.defMeasurement('infoHome') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('description',:string)
end

}


defApplication('Foreign', 'ForeignApp') {|app|

app.shortDescription = "This is a simple foreign app." 
app.path="/root/Code/app 32000 33000 31000 > /root/Code/logfile" 


app.defMeasurement('infoForeign') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('description',:string)
end

}


defApplication('Pigeon', 'PigeonApp') {|app|

app.shortDescription = "This is a simple pigeon app." 
app.path="/root/Code/app 192.168.0.1 32000 33000 192.168.0.3 32000 33000  > /root/Code/logfile " 


app.defMeasurement('infoPigeon') do |mp|
     mp.defMetric('ID',:long)
     mp.defMetric('location',:float)
     mp.defMetric('st',:float)
     mp.defMetric('et',:float)
     mp.defMetric('description',:string)
end


app.defMeasurement('locPigeon') do |mp|
     mp.defMetric('location',:float)
     mp.defMetric('description',:string)
end

}




defGroup('homeHosts', [1,1]) {|node|

node.addApplication('Home') {|app|
#app.measure('info', :interval => 10)
app.measure('infoHome', :samples => 1)
}

 node.net.w0.mode = "adhoc"
 node.net.w0.type = 'g'
 node.net.w0.channel = "6"
 node.net.w0.essid = "test"
 node.net.w0.ip = "192.168.0.1"



}


defGroup('foreignHosts', [1,3]) {|node|

node.addApplication('Foreign') {|app|
#app.measure('info', :interval => 10)
app.measure('infoForeign', :samples => 1)
}

 node.net.w0.mode = "adhoc"
 node.net.w0.type = 'g'
 node.net.w0.channel = "6"
 node.net.w0.essid = "test"
 node.net.w0.ip = "192.168.0.3"



}


defGroup('pigeons', [1,2]) {|node|

node.addApplication('Pigeon') {|app|
app.measure('infoPigeon', :samples => 1)
app.measure('locPigeon', :samples => 1)
}

 node.net.w0.mode = "adhoc"
 node.net.w0.type = 'g'
 node.net.w0.channel = "6"
 node.net.w0.essid = "test"
 node.net.w0.ip = "192.168.0.2"


}


whenAllInstalled() {|node|

info "This is my first OMF experiment" 

wait 10

group("homeHosts").startApplications

group("foreignHosts").startApplications

wait 5

group("pigeons").startApplications

info "All my Applications are started now..." 

wait 300

group("pigeons").exec("killall -s9 app")

wait 5
 
group("homeHosts").exec("killall -s9 app")

group("foreignHosts").exec("killall -s9 app")

allGroups.stopApplications
info "All my Applications are stopped now." 

Experiment.done

}
